function SpawnNewMMAI()
{
	%brickgroup = eval("return Brickgroup_"@($Server::LAN ? 999999 : getNumKeyID())@";");
	if(!isObject(%brickgroup))
	{
		%brickgroup = new SimGroup(){};
		%deleteGroup = 1;
	}
	%bot = new AIPlayer()
	{ datablock = PlayerNoJet.getID(); position = getWords(%trans = %brickgroup.getBrickSpawnpoint(), 0, 2); };
	if(%deleteGroup) %brickgroup.delete();
	if(!isObject(%bot)) return;
	%bot.setTransform(%trans);
	%cl = new ScriptObject()
	{
		class = "FakeClientSO";
		player = %bot;
		isBot = 1;
	};
	if(!isObject(%cl))
	{ %bot.delete(); return; }
	%bot.client = %cl;
	%bot.trySetInd("Unknown");
	%cl.isFemale = getRandom(0, 1);
	%cl.botName = getBotName(%cl.isFemale ? "Female" : "Male");
	$MM_Bot[-1+$MM_Bots++] = %cl;
	%bot.AILoop = %bot.schedule(1000, "MM_AILoop", 0, "", getSimTime());
	return %cl;
}

function MM_clearBots()
{
	for(%i=0;%i<$MM_Bots;%i++)
	{
		if(isObject(%pl = (%cl = $MM_Bot[%i]).player))
			%pl.delete();
		if(isObject(%cl))
			%cl.delete();
	}
	$MM_Bots = 0;
}

function getBotName(%gender)
{
	switch$(%gender)
	{
		case "Male":
			%list = "Bob Daniel Gordon Graham Harold Jack John Johnson Matthew Micheal Mike Peter";
			return getWord(%list, getRandom(0, getWordCount(%list) - 1));
		case "Female":
			%list = "Alice Barbara Jane Jessica Rebecca Sally Samantha Sarah";
			return getWord(%list, getRandom(0, getWordCount(%list) - 1));
	}
}

function AIPlayer::MM_AILoop(%bot, %targ, %goal, %last)
{
	if(!isObject(%cl = %bot.client))
	{ %bot.kill(); return; }
	cancel(%bot.AILoop);
	%status = %cl.status;
	if(!isObject(%bot.getMountedImage(0)))
	{ %bot.mountImage(ButterflyKnifeImage.getID(), 0); fixArmReady(%bot); }
	%pos = %bot.getHackPosition();
	%eye = %bot.getEyePoint();
	%len = vectorDist(%last, %now = getSimTime());
//	if(%cl.status $= "Murderer" && isObject(%targ))
//	{
//		if((%dist = vectorDist(%pos, %loc = %targ.getHackPosition())) >= 40 || isObject(%ray = containerRaycast(%eye, %loc, $Typemasks::fxBrickObjectType)))
//		{
//			%targ = ""; %bot.stop();
//			%bot.setMoveX(0); %bot.setMoveY(0);
//			%bot.setAimObject(0);
//			%bot.setImageTrigger(0, 0);
//			%bot.MM_AILoop(0, "", %now);
//			return;
//		}
//		else
//		{
//			%bot.setMoveY(10);
//			if(%dist <= 4 && %bot.getImageState(0) $= "Armed")
//				%bot.setImageTrigger(0, 0);
//			else if(%dist <= 8)
//				%bot.setImageTrigger(0, 1);
//			else if(%dist <= 12)
//				%bot.setImageTrigger(0, 0);
//		}
//	}
//	else
//	{
		if(%cl.status $= "Innocent") %range = 16;
		else if(%cl.status $= "Murderer") %range = 32;
		initContainerRadiusSearch(%pos, %range, $Typemasks::PlayerObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%bot == %obj) continue;
			if(%obj.getState() $= "DEAD") continue;
			if(!isObject(%this = %obj.client)) continue;
			if(%this.excluded) continue;
			if(isObject(containerRaycast(%eye, %obj.getHackPosition(), $Typemasks::fxBrickObjectType))) continue;
			%item[-1+%items++] = %obj;
			if(%this.status $= "Murderer")
				%murderers++;
		}
		if(%cl.status $= "Innocent")
		{
			for(%i=0;%i<%items;%i++)
			{
				%obj = %item[%i];
				if(%obj.provenInnocent || (%obj.unmasked && %obj.status !$= "Murderer"))
					continue;
				else if(%obj.unmasked) %murderer = 1;
				%list[-1+%count++] = %obj;
			}
			if(%count == 0 && (%goal $= "" || (vectorLen(%bot.getVelocity()) < 1 && %time > 1) || %time > 5))
			{
				%time = 0;
				%bot.setImageTrigger(0, 0);
				%bot.stop(); %bot.setAimObject(0);
				%bot.setMoveX(0); %bot.setMoveY(0);
				%goal = vectorAdd(%pos, getRandom(-16, 16) SPC getRandom(-16, 16) SPC 1);
				if(vectorDist(%pos, %goal) > 16) %goal = "";
			}
			else if(%count == 0)
			{
				%time += %len;
				%bot.setImageTrigger(0, 0);
				if(vectorDist(%pos, %bot.goal) <= 1 || isObject(%ray = containerRaycast(%eye, %goal, $Typemasks::fxBrickObjectType)))
					%goal = "";
				else
				{
					%bot.setAimLocation(%goal);
					%bot.setMoveY(10);
				}
			}
			else
			{
				%goal = "";
				for(%i=0;%i<%count;%i++)
				{
					if(%murderer && !%list[%i].unmasked) continue;
					if((%dist = vectorDist(%pos, %item[%i].getHackPosition())) < %closest || %closest $= "")
					{
						%closest = %dist;
						%target = %item[%i];
					}
				}
				%bot.setAimObject(%target);
				%bot.setMoveObject(%target);
				%bot.setMoveY(-10);
				if(%closest <= 4 && %bot.getImageState(0) $= "Armed")
					%bot.setImageTrigger(0, 0);
				else if(%closest <= 8)
					%bot.setImageTrigger(0, 1);
				else if(%closest <= 12)
					%bot.setImageTrigger(0, 0);
			}
		}
		else if(%cl.status $= "Murderer")
		{
			if(%bot.aggressive)
			{
				for(%i=0;%i<%items;%i++)
				{
					if(%item[%i].client.status $= "Murderer") continue;
					if((%dist = vectorDist(%pos, %item[%i].getHackPosition())) < %closest || %closest $= "")
					{
						%closest = %dist;
						%target = %item[%i];
					}
				}
				%bot.setAimObject(%target);
				%bot.setMoveObject(%target);
				%bot.setMoveY(10);
				if(%closest <= 4 && %bot.getImageState(0) $= "Armed")
					%bot.setImageTrigger(0, 0);
				else if(%closest <= 8)
					%bot.setImageTrigger(0, 1);
				else if(%closest <= 12)
					%bot.setImageTrigger(0, 0);
			}
			else if((%items - %murderers) == 1)
				%bot.aggressive = 1;
			else if(%goal $= "" || (vectorLen(%bot.getVelocity()) < 1 && %time > 1) || %time > 5)
			{
				%time = 0;
				%bot.setImageTrigger(0, 0);
				%bot.stop(); %bot.setAimObject(0);
				%bot.setMoveX(0); %bot.setMoveY(0);
				%goal = vectorAdd(%pos, getRandom(-16, 16) SPC getRandom(-16, 16) SPC 1);
				if(vectorDist(%pos, %goal) > 16) %goal = "";
			}
			else
			{
				%time += %len;
				%bot.setImageTrigger(0, 0);
				if(vectorDist(%pos, %bot.goal) <= 1 || isObject(%ray = containerRaycast(%eye, %goal, $Typemasks::fxBrickObjectType)))
					%goal = "";
				else
				{
					%bot.setAimLocation(%goal);
					%bot.setMoveY(10);
				}
			}
		}
//	}
	%bot.AILoop = %bot.schedule(16, "MM_AILoop", %targ, %goal, %now);
}