registerInputEvent("fxDtsBrick", "MM_onNewRound", "Self fxDtsBrick");
registerInputEvent("fxDtsBrick", "MM_onInnocent", "Self fxDtsBrick\tPlayer Player\tClient GameConnection");
registerInputEvent("fxDtsBrick", "MM_onMurderer", "Self fxDtsBrick\tPlayer Player\tClient GameConnection");
registerInputEvent("fxDtsBrick", "MM_onDetective", "Self fxDtsBrick\tPlayer Player\tClient GameConnection");
registerInputEvent("fxDtsBrick", "MM_onObserver", "Self fxDtsBrick\tPlayer Player\tClient GameConnection");

registerOutputEvent("fxDtsBrick", "MM_setBlackout", "bool", 1);
registerOutputEvent("fxDtsBrick", "MM_checkStatus", "", 1);


function fxDtsBrick::MM_onNewRound(%brick, %cl)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Client"] = %cl;   //This is whoever has the highest score. Shut up.
	%brick.processInputEvent("MM_onNewRound", %cl);
}

function fxDtsBrick::MM_onInnocent(%brick, %cl)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %cl.player;
	$InputTarget_["Client"] = %cl;
	%brick.processInputEvent("MM_onInnocent", %cl);
}

function fxDtsBrick::MM_onMurderer(%brick, %cl)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %cl.player;
	$InputTarget_["Client"] = %cl;
	%brick.processInputEvent("MM_onMurderer", %cl);
}

function fxDtsBrick::MM_onDetective(%brick, %cl)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %cl.player;
	$InputTarget_["Client"] = %cl;
	%brick.processInputEvent("MM_onDetective", %cl);
}

function fxDtsBrick::MM_onObserver(%brick, %cl)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %cl.player;
	$InputTarget_["Client"] = %cl;
	%brick.processInputEvent("MM_onObserver", %cl);
}


function fxDtsBrick::MM_setBlackout(%brick, %value, %cl)
{
	if(%value != $Blackout)
		messageAll('', (%value ? "\c2Look out, a \c3Blackout\c2 has begun." : "\c2You got lucky, the \c3Blackout\c2 is over."));
	MM_setBlackout(%value);
}

function fxDtsBrick::MM_checkStatus(%brick, %cl)
{
	if(%cl.status $= "Innocent") %brick.schedule(16, "MM_onInnocent", %cl);
	if(%cl.status $= "Murderer") %brick.schedule(16, "MM_onMurderer", %cl);
	if(%cl.status $= "Detective") %brick.schedule(16, "MM_onDetective", %cl);
	if(%cl.status $= "Observer") %brick.schedule(16, "MM_onObserver", %cl);
}