if($DamageType::MM_YouMoron $= "")
	AddDamageType("MM_YouMoron", '%1 is a moron!', '%2 made a moron out of %1!', 1, 1);

package murderMystery
{
	function filterString(%text, %tokens)  //This isn't default - cover our asses
	{
		for(%i=0;%i<strLen(%text);%i++)
			if(strPos(%tokens, getSubStr(%text, %i, 1)) != -1)
				%result = %result@getSubStr(%text, %i, 1);
		return %result;
	}
	
	function Observer::onTrigger(%armor, %this, %trig, %tog)
	{
		Parent::onTrigger(%armor, %this, %trig, %tog);
		if($MurderMystery && isObject(%this.getControllingClient()) && !%this.excluded && %trig == 0 && %tog)
		{
			%brickgroup = eval("return Brickgroup_"@getNumKeyID()@";");
			if(!isObject(%brickgroup))
			{
				%brickgroup = new SimGroup(){};
				%deleteGroup = 1;
			}
			%this.getControllingClient().createPlayer(%brickgroup.getBrickSpawnpoint());
			if(%deleteGroup) %brickgroup.delete();
		}
	}
	
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(isObject(%cl = %this.client) && %cl.excluded && !isObject(%this.getMountedImage(0)))
		{
			%eye = vectorScale(%this.getEyeVector(), 20);
			%pos = %this.getEyePoint();
			%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
			%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %this));
			if(!isObject(%hit) || %hit.getClassName() !$= "Player" || (%name = %hit.client.name) $= "" || %hit.unmasking)
				return;
			%hit.mm_Reveal(5);
		}
		else if(isObject(%cl) && %cl.status $= "Detective" && !isObject(%this.getMountedImage(0)))
		{
			%eye = vectorScale(%this.getEyeVector(), 10);
			%pos = %this.getEyePoint();
			%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
			%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %this));
			if(!isObject(%hit) || %hit.getClassName() !$= "Player" || (%name = %hit.client.name) $= "" || %hit.unmasking)
				return;
			%hit.mm_Reveal(20, %cl);
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function GameConnection::createPlayer(%cl, %trans)
	{
		if($murderMystery && !$murderMystery_overrideSpawnBlock && !%cl.excluded)
		{
			if(!%cl.canSpawn)
			{
				%cl.chatMessage("\c6You are now \c3ready to spawn\c6, and will spawn when the next round begins!");
				%cl.chatMessage("\c7Until then, you will not be able to be heard by living players.");
				%cl.camera.setTransform(vectorAdd(getWords(%trans, 0, 2), "0 0 1.325") SPC getWords(%trans, 3, 6));
				%cl.setControlObject(%cl.camera);
				%cl.status = "Waiting";
				%cl.canSpawn = 1;
			}
			return;
		}
		else
			Parent::createPlayer(%cl, %trans);
		if($murderMystery)
			if(%cl.excluded)
				%cl.player.setShapeNameColor("0.4 0.4 0.4");
			else
			{
				%cl.player.spawnTrans = %cl.player.getTransform();
				if($NoNames)
				{
					//%betaCl = new ScriptObject()
					//{
					//	class = "FakeClientSO";
					//	
					//	accent = %cl.accent;
					//	accentColor = %cl.accentColor;
					//	chest = %cl.chest;
					//	chestColor = %cl.chestColor;
					//	decalName = %cl.decalName;
					//	faceName = %cl.faceName;
					//	hat = %cl.hat;
					//	hatColor = %cl.hatColor;
					//	headColor = %cl.headColor;
					//	hip = %cl.hip;
					//	hipColor = %cl.hipColor;
					//	larm = %cl.larm;
					//	larmColor = %cl.larmColor;
					//	lhand = %cl.lhand;
					//	lhandColor = %cl.lhandColor;
					//	lleg = %cl.lleg;
					//	llegColor = %cl.llegColor;
					//	pack = %cl.pack;
					//	packColor = %cl.packColor;
					//	secondPack = %cl.secondPack;
					//	secondPackColor = %cl.secondPackColor;
					//	rarm = %cl.rarm;
					//	rarmColor = %cl.rarmColor;
					//	rhand = %cl.rhand;
					//	rhandColor = %cl.rhandColor;
					//	rleg = %cl.rleg;
					//	rlegColor = %cl.rlegColor;
					//};
					//%betaCl.excluded = 1;
					//%betaCl.createPlayer(%trans);
					//%player = %betaCl.player;
					//%betaCl.player = "";
					//%betaCl.delete();
					//%cl.player.delete();
					//%cl.setControlObject(%player);
					//%player.client = %cl;
					//%cl.player = %player;
					if($Pref::Server::ShapeNamePassword !$= "")
						%cl.player.setShapeName("", $Pref::Server::ShapeNamePassword);
					%cl.player.setShapeNameDistance(0);
					%cl.player.trySetInd("Unknown");
					%cl.player.clearTools();
				}
				%cl.player.afkLoop();
			}
	}
	
	function GameConnection::onDeath(%cl, %col, %killer, %damageType, %damageArea)
	{
		if($murderMystery && !%cl.excluded)
		{
			if($EvilVignette)
				commandToClient(%cl, 'SetVignette', 1, "0 0 0 0");
			if(%cl.isBot) %name = %cl.botName; else %name = %cl.name;
			if(%killer.isBot) %other = %killer.botName; else %other = %killer.name;
			if(%damageType == $DamageType::Fall)
				if(%cl.status $= "Detective")
					messageAll('', "<color:0000ff>"@%name@"\c6 has fallen to "@(%cl.isFemale?"her":"his")@" death!");
				else if(!%cl.player.unmasked && $NeverReveal)
					messageAll('', "<color:ffff00>"@%name@"\c6 has fallen to "@(%cl.isFemale?"her":"his")@" death!");
				else if(%cl.status $= "Murderer")
					messageAll('', "<color:ff0000>"@%name@"\c6 has fallen to "@(%cl.isFemale?"her":"his")@" death!");
				else
					messageAll('', "<color:00ff00>"@%name@"\c6 has fallen to "@(%cl.isFemale?"her":"his")@" death!");
			else if((!isObject(%killer) || %cl == %killer) && !%cl.player.killedInnocent)
			{
				if(%cl.status $= "Detective")
					messageAll('', "<color:0000ff>"@%name@"\c6 has killed "@(%cl.isFemale?"her":"him")@"self!");
				else if(!%cl.player.unmasked && $NeverReveal)
					messageAll('', "<color:ffff00>"@%name@"\c6 has killed "@(%cl.isFemale?"her":"him")@"self!");
				else if(%cl.status $= "Murderer")
					messageAll('', "<color:ff0000>"@%name@"\c6 has killed "@(%cl.isFemale?"her":"him")@"self!");
				else
					messageAll('', "<color:00ff00>"@%name@"\c6 has killed "@(%cl.isFemale?"her":"him")@"self!");
			}
			else
			{
				cancel($MM_Autoreveal);
				$MM_Autoreveal = schedule($MM_UseAutoReveal * 1000, 0, "mm_Autoreveal");
				if(%cl.status $= "Innocent")
				{
					if(%killer.excluded && %killer.cheater)
						messageAll('', "\c6Cheater "@%other@"\c6 killed "@($NeverReveal && !%cl.player.unmasked?"<color:ffff00>":"<color:00ff00>")@%name@"\c6!");
					else if(%killer.status $= "Innocent")
					{
						%percent = getRandom(1, 100);
						if(%percent <= $murderPC)
						{
							messageAll('', "<color:ff0000>"@%other@"\c6 killed <color:00ff00>"@%name@"\c6, another <color:00ff00>Innocent\c6! "@(%killer.isFemale?"She":"He")@" is now a murderer!");
							%killer.points += 3;
							%killer.centerPrint("\c6+3 points", 5);
							%killer.status = "Murderer";
							%killer.mm_CriminalHelper();
						}
						else
						{
							messageAll('', "<color:00ff00>"@%other@"\c6 killed <color:00ff00>"@%name@"\c6, another <color:00ff00>Innocent\c6, and was slain!");
							%killer.player.killedInnocent = 1;
							%killer.player.damage(%this, %this.position, 10000, $DamageType::Suicide);
							%killer.points -= 5;
							%killer.centerPrint("\c6-5 points", 5);
						}
						if($lifecount != 1)
							%cl.lives++;
					}
					else if(%killer.status $= "Murderer")
					{
						%msg = getMurderMessage(%damageType);
						for(%i=0;%i<ClientGroup.getCount();%i++)
						{
							%this = ClientGroup.getObject(%i);
							if((%this.status $= "Innocent" || %this.status $= "Detective") && (isObject(%this.player) || $AlwaysHide))
								%this.chatMessage(($NeverReveal && !%cl.player.unmasked?"<color:ffff00>":"<color:00ff00>")@%name@"\c6 was "@%msg@"!");
							else
								%this.chatMessage("<color:00ff00>"@%name@"\c6 was "@%msg@" by <color:ff0000>"@%other@"\c6!");
						}
						%cl.chatMessage("\c6You were killed by <color:ff0000>"@%other@"\c6!");
						%killer.points += 3;
						%killer.centerPrint("\c6+3 points",5);//"@(!%killer.player.dirtyHands?"<br>\c6You have soiled your hands!":""), 5);
						//%killer.player.dirtyHands = 1;
						%killer.player.innocentsSlaughtered++;
						if(%killer.player.innocentsSlaughtered >= 3)
							%killer.player.earnAchievement("MA", "Backyard Butcherer", "Kill three innocents in a single run!", 5);
						if(%killer.player.innocentsSlaughtered >= 7)
							%killer.player.earnAchievement("MB", "Streamlined Slaughterer", "Slaughter seven innocents in a single run!", 10);
						if(%killer.player.innocentsSlaughtered >= 15)
							%killer.player.earnAchievement("MC", "Mainstream Murderer", "Massacre fifteen innocents in a single run!", 20);
					}
				}
				else if(%cl.status $= "Murderer")
				{
					if(%killer.excluded && %killer.cheater)
						messageAll('', "\c6Cheater "@%other@"\c6 killed "@($NeverReveal && !%cl.player.unmasked?"<color:ffff00>":"<color:ff0000>")@%name@"\c6!");
					else if(%killer.status $= "Innocent")
					{
						messageAll('', "<color:00ff00>"@%other@"\c6 killed <color:ff0000>"@%name@"\c6, a murderer!");
						%killer.points += 3;
						if($NoNames)
							%killer.player.trySetInd("Innocent");
						else
							%killer.player.setShapeNameColor("0.0 1.0 0.0");
						%killer.centerPrint("\c6+3 points", 5);
						%killer.player.provenInnocent = 1;
						%killer.player.unmasked = 1;
					}
					else if(%killer.status $= "Murderer")
					{
						%msg = getMurderMessage(%damageType);
						for(%i=0;%i<ClientGroup.getCount();%i++)
						{
							%this = ClientGroup.getObject(%i);
							if((%this.status $= "Innocent" || %this.status $= "Detective") && (isObject(%this.player) || $AlwaysHide))
								%this.chatMessage(($NeverReveal && !%cl.player.unmasked?"<color:ffff00>":"<color:ff0000>")@%name@"\c6 was "@%msg@($NeverReveal && !%cl.player.unmasked?"":" by one of his own")@"!");
							else
								%this.chatMessage("<color:ff0000>"@%name@"\c6 was "@%msg@" by <color:ff0000>"@%other@"\c6!");
						}
						%killer.points -= 5;
						%killer.centerPrint("\c6-5 points"@(!%killer.player.dirtyHands?"<br>\c6You have soiled your hands!":""), 5);
						%killer.player.dirtyHands = 1;
					}
					else if(%killer.status $= "Detective")
					{
						messageAll('', "<color:0000ff>"@%other@"\c6 arrested <color:ff0000>"@%name@"\c6!");
						%killer.points += 3;
						%killer.centerPrint("\c6+3 points", 5);
						if(!%cl.player.resisting)
							%cl.player.earnAchievement("NR", "Repentitive", "Surrender yourself to the authorities without ever drawing a weapon!", 20);
					}
				}
				else if(%cl.status $= "Detective")
				{
					if(%killer.excluded && %killer.cheater)
						messageAll('', "\c6Cheater "@%other@"\c6 killed <color:0000ff>"@%name@"\c6!");
					else if(%killer.status $= "Murderer")
					{
						%msg = getMurderMessage(%damageType);
						for(%i=0;%i<ClientGroup.getCount();%i++)
						{
							%this = ClientGroup.getObject(%i);
							if((%this.status $= "Innocent" || %this.status $= "Detective") && (isObject(%this.player) || $AlwaysHide))
								%this.chatMessage("<color:0000ff>"@%name@"\c6 was "@%msg@"!");
							else
								%this.chatMessage("<color:0000ff>"@%cl.name@"\c6 was "@%msg@" by <color:ff0000>"@%killer.name@"\c6!");
						}
						%killer.points += 5;
						%killer.centerPrint("\c6+5 points", 5);
						%killer.player.dirtyHands = 1;
						%killer.player.innocentsSlaughtered++;
						if(%killer.player.innocentsSlaughtered >= 3)
							%killer.player.earnAchievement("MA", "Backyard Butcherer", "Kill three innocents in a single run!", 5);
						if(%killer.player.innocentsSlaughtered >= 7)
							%killer.player.earnAchievement("MB", "Fresh Meat", "Slaughter seven innocents in a single run!", 10);
						if(%killer.player.innocentsSlaughtered >= 15)
							%killer.player.earnAchievement("MC", "Mainstream Murderer", "Massacre seven innocents in a single run!", 10);
					}
				}
			}
			if(%cl.isBot)
				%cl.delete();
			else
			{
				%trans = %cl.player.getTransform();
				%cl.camera.setTransform(vectorAdd(getWords(%trans, 0, 2), "0 0 1.325") SPC getWords(%trans, 3, 6));
				%cl.setControlObject(%cl.camera);
				%pl = %cl.player; %cl.player = "";
				if(isObject(%pl.indLight))
					%pl.indLight.delete();
				if(isObject(%pl.indPlayer))
					%pl.indPlayer.delete();
				%pl.setShapeName("");
				%cl.hasSword = 0;
				%cl.hasGun = 0;
				if(!$murderMystery_overrideSpawnBlock)
				{
					%cl.respawnSched = %cl.schedule(3000, "mm_respawn");
					%cl.chatMessage("\c7You can no longer be heard by living players.");
				}
			}
			return;
		}
		else
			Parent::onDeath(%cl, %col, %killer, %damageType, %damageArea);
	}
	
	function FakeClientSO::onDeath(%cl, %col, %killer, %damageType, %damageArea)
	{
		GameConnection::onDeath(%cl, %col, %killer, %damageType, %damageArea);
	}
	
	function GameConnection::mm_respawn(%cl)
	{
		return;
		if($infLives)
			%lives = "?";
		else
		{
			if(%cl.lives-- <= 0)
				return;
			%lives = %cl.lives;
		}
		%brickgroup = eval("return Brickgroup_"@getNumKeyID()@";");
		if(!isObject(%brickgroup))
		{
			%brickgroup = new SimGroup(){};
			%deleteGroup = 1;
		}
		$murderMystery_overrideSpawnBlock = 1;
		%cl.createPlayer(%brickgroup.getBrickSpawnpoint());
		$murderMystery_overrideSpawnBlock = 0;
		%cl.centerPrint("<color:ffffff>You have "@%lives@" li"@(%lives == 1?"fe":"ves")@" left.", 3);
	//	if(getRandom(0, 4) >= 3)
	//		%cl.status = "Innocent";
	//	else
	//		%cl.status = "Murderer";
		%cl.player.clearTools();
		%cl.player.changeDatablock(PlayerNoJet);
		if($KnifeOnly)
		{
			%cl.player.tool0 = ButterflyKnifeItem.getID();
			messageClient(%cl, 'MsgItemPickup', '', 0, ButterflyKnifeItem.getID(), 1);
		}
		else
		{
			%cl.player.tool0 = SwordItem.getID();
			messageClient(%cl, 'MsgItemPickup', '', 0, SwordItem.getID(), 1);
			if(%cl.hasSword)
			{
				%cl.player.tool1 = ButterflyKnifeItem.getID();
				messageClient(%cl, 'MsgItemPickup', '', 1, ButterflyKnifeItem.getID(), 1);
			}
			if(%cl.hasGun)
			{
				%cl.player.tool2 = GunItem.getID();
				messageClient(%cl, 'MsgItemPickup', '', 2, GunItem.getID(), 1);
			}
			if(%cl.hasSniper)
			{
				%cl.player.tool3 = SniperRifleItem.getID();
				messageClient(%cl, 'MsgItemPickup', '', 3, SniperRifleItem.getID(), 1);
			}
		}
		if(%deleteGroup)
			%brickgroup.delete();
	}
	
	function getMurderMessage(%damageType)
	{
		%word0 = "bloodily\tbrutally\tcruelly\thorribly\tmercilessly\tmessily\truthlessly\tviciously\tviolently";
		//Charles:	Mercilessly, ruthlessly, violently.
		//Xalos:	Bloodily, brutally, cruelly, horribly, messily, viciously.
		%word1 = "butchered\tcleaved\tcut down\tdecapitated\tdisembodied\tdismembered\tdissected\tmurdered\tshot down\tshredded\tslaughtered";
		%weap1 = "knife\tknife\knife\tall\tall\tall\tall\tknife\tall\tbullet\tknife\tall";
		//Charles:	Cleaved, cut down.
		//Pvt. Block:	Decapitated, shredded.
		//Xalos:	Butchered, disembodied, dismembered, dissected, murdered, shot down, slaughtered.
		for(%i=0;%i<getFieldCount(%word1);%i++)
			if(getField(%weap1, %i) $= "All")
				%word2 = %word2 TAB getField(%word1, %i);
		if(%damageType == $DamageType::SniperRifle)
			for(%i=0;%i<getFieldCount(%word1);%i++)
				if(getField(%weap1, %i) $= "Sniper")
					%word2 = %word2 TAB getField(%word1, %i);
		if(%damageType == $DamageType::SniperRifle || %damageType == $DamageType::Gun)
			for(%i=0;%i<getFieldCount(%word1);%i++)
				if(getField(%weap1, %i) $= "Bullet")
					%word2 = %word2 TAB getField(%word1, %i);
		if(%damageType == $DamageType::Sword || %damageType == $DamageType::ButterflyKnifeDirect)
			for(%i=0;%i<getFieldCount(%word1);%i++)
				if(getField(%weap1, %i) $= "Knife")
					%word2 = %word2 TAB getField(%word1, %i);
		%word2 = trim(%word2);
		return getField(%word0, getRandom(0, getFieldCount(%word0) - 1)) SPC getField(%word2, getRandom(0, getFieldCount(%word2) - 1));
	}
	
	function GunImage::onFire(%data, %player, %slot)
	{
		if(!$murderMystery || %player.client.excluded || %player.client.status $= "Detective")
		{
			Parent::onFire(%data, %player, %slot);
			return;
		}
		if(%player.noFire)
			return;
		if(isObject(%player.client))
		{
			while(%player.client.bullets <= 0)
				if(%player.client.score >= 1)
				{
					%player.client.score -= 1;
					%player.client.bullets += 3;
				}
				else
					return;
			%player.client.bullets--;
		}
		Parent::onFire(%data, %player, %slot);
	}
	
	function minigameCanDamage(%attack, %victim)
	{
		if(!$murderMystery)
			return Parent::minigameCanDamage(%attack, %victim);
		if($murderMystery_noDamage || $murderMystery_overrideSpawnBlock)
			return 0;
		if(%victim.getClassName() $= "fxDtsBrick")
			return 0;
		switch$(%attack.getClassName())
		{
			case "ScriptObject":
				%attackCl = %attack;
			case "AIPlayer":
				%attackCl = %attack.client;
			case "GameConnection":
				%attackCl = %attack;
			case "Player":
				%attackCl = %attack.client;
			case "Projectile":
				%attackCl = %attack.client;
			default:
				return Parent::minigameCanDamage(%attack, %victim);
		}
		switch$(%victim.getClassName())
		{
			case "ScriptObject":
				%victimCl = %victim;
			case "AIPlayer":
				%victimCl = %victim.client;
			case "GameConnection":
				%victimCl = %victim;
			case "Player":
				%victimCl = %victim.client;
			case "Projectile":
				%victimCl = %victim.client;
			default:
				return Parent::minigameCanDamage(%attack, %victim);
		}
		if(%attackCl.excluded && %attackCl.cheater)
			return 1;
		if(%attackCl.excluded && %victimCl.excluded)
			return Parent::minigameCanDamage(%attack, %victim);
		if(%attackCl.excluded || %victimCl.excluded || %victimcl.cheater)
			return 0;
		if(%attackCl.status $= "Detective")
		{
			if(!%victimCl.player.unmasking)
				%victimCl.player.mm_Reveal(20, %attackCl);
			else if(%victimCl.status $= "Murderer" && %victimCl.player.unmasked)
				return 1;
			return 0;
		}
		if(%victimCl.status $= "Detective" && %attackCl.status !$= "Murderer")
			return 0;
		if(%victimCl.status $= "Innocent" && %victimCl.player.unmasked && %attackCl.status $= "Innocent")
			return 0;
		if(%victimCl.status $= "Murderer" && (!%victimCl.player.resisting))
			return 0;
		return 1;
	}
	
	function Armor::damage(%data, %this, %proj, %position, %damage, %damageType)
	{
		if(!$murderMystery)
		{
			Parent::damage(%data, %this, %proj, %position, %damage, %damageType);
			return;
		}
		if(%this.indicator)
		{
			%this.player.damage(%proj, %position, %damage, %damageType);
			return;
		}
		if(%this.getClassName() $= "Player" && isObject(%this.client) && %this.client.status $= "Innocent" && %this.unmasked)
			if(%damage >= (%data.maxDamage - %this.getDamageLevel()))
				if(isObject(%proj) && isObject(%proj.client) && %proj.client != %this.client && %proj.client.status $= "Innocent" && isObject(%moron = %proj.client.player))
				{
					%moron.unmasked = 0;   //If this is one we get an infinite loop.
					%moron.damage(%this, %moron.position, 10000, $DamageType::MM_YouMoron);
					return;
				}
		Parent::damage(%data, %this, %proj, %position, %damage, %damageType);
	}
	
	function Player::allowFiring(%pl)
	{
		%pl.noFire = 0;
		if(!$murderMystery || !isObject(%pl) || !isObject(%image = %pl.getMountedImage(0)))
			return;
		cancel(%pl.changeSched);
		if(%image.getName() $= "GunImage")
		{
			if(%pl.getDatablock().getName() !$= "PlayerSlowArmor")
				%pl.setDatablock(PlayerSlowArmor.getID());
		}
		else if(%image.getName() $= "SniperRifleImage")
		{
			if(%pl.getDatablock().getName() !$= "PlayerReallySlowArmor")
				%pl.setDatablock(PlayerReallySlowArmor.getID());
		}
		else if(%pl.getDatablock().getName() !$= "PlayerNoJet")
			%pl.setDatablock(PlayerNoJet.getID());
	}
	
	function Player::delete(%pl)
	{
		if(isObject(%pl.indLight))
			%pl.indLight.delete();
		if(isObject(%pl.indPlayer))
			%pl.indPlayer.delete();
		Parent::delete(%pl);
	}
	
	function Player::earnAchievement(%pl, %nick, %title, %desc, %reward)
	{
		if(!isObject(%pl.client))
			return;
		%cl = %pl.client;
		%id = %cl.bl_id;
		if($MM::EarnedAchievement[%nick, %id])
			return;
		%cl.chatMessage("\c6You earned the <color:00FF00>"@%title@"\c6 Achievement!");
		%cl.chatMessage("<color:FFFF00>"@%desc@(%reward!=0?"   \c6(<color:0000FF>+"@%reward@" points!\c6)":""));
		messageAll('', "\c6"@%cl.name@" has earned the <color:00FF00>"@%title@"\c6 Achievement!");
		%cl.centerPrint("<color:00FF00>"@%title@"<br><color:FFFF00>"@%desc, 5);
		if(%reward != 0)
		{
			%cl.schedule(1750, "centerPrint", "<color:00FF00>"@%title@"<br><color:0000FF>+"@%reward@" points!", 5);
			%cl.schedule(3250, "centerPrint", "<color:00FF00>"@%title@"<br><color:FFFF00>"@%desc, 1.75);
			%cl.points += %reward;
		}
		$MM::EarnedAchievement[%nick, %id] = 1;
	}
	
	function Player::mm_CriminalHelper(%pl)
	{
		cancel(%pl.crimHelpLoop);   //Kill off duplicate processes if any are trailing behind us.
		if(!isObject(%pl) || %pl.getState() $= "DEAD" || !isObject(%cl = %pl.client))
			return;
		%pl.crimHelpLoop = %pl.schedule(16, "mm_CriminalHelper");
		%eye = vectorScale(%pl.getEyeVector(), 20);
		%pos = %pl.getEyePoint();
		%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
		%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %pl));
		if(!isObject(%hit) || %hit.getClassName() !$= "Player" || (%name = %hit.client.name) $= "")
			return;
		if(%hit.client.status $= "Murderer")
			%cl.centerPrint("<br><br><br>\c6"@%name@" is a murderer too!<br><color:00ff00>Do not kill "@(%cl.isFemale?"her":"him")@"!", 3);
		else if(%hit.client.status $= "Detective")
			%cl.centerPrint("<br><br><br>\c6"@%name@" is a detective!<br><color:ff0000>Kill "@(%cl.isFemale?"her":"him")@" as soon as possible!", 3);
		else
			%cl.centerPrint("<br><br><br>\c6"@%name@" is innocent!<br>", 3);
	}
	
	function Player::mm_DetectiveHelper(%pl)
	{
		cancel(%pl.detHelpLoop);   //Kill off duplicate processes if any are trailing behind us.
		if(!isObject(%pl) || %pl.getState() $= "DEAD" || !isObject(%cl = %pl.client))
			return;
		%pl.detHelpLoop = %pl.schedule(16, "mm_DetectiveHelper");
		%eye = vectorScale(%pl.getEyeVector(), 20);
		%pos = %pl.getEyePoint();
		%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
		%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %pl));
		if(!isObject(%hit) || %hit.getClassName() !$= "Player" || (%name = %hit.client.name) $= "")
			return;
		if(!%hit.unmasking && !%hit.unmasked)
			%cl.centerPrint("<br><br><br>\c6Click "@%name@" to prove his innocence or guilt!<br>\c6(It works at a pretty long range, so stay safe.)", 3);
		else
			commandToClient(%cl, 'clearCenterPrint');
	}
	
	function Player::mm_InnocentHelper(%pl)
	{
		%pl.mm_InnocentVignette();
		return;
		cancel(%pl.innoHelpLoop);   //Kill off duplicate processes if any are trailing behind us.
		if(!isObject(%pl) || %pl.getState() $= "DEAD" || !isObject(%cl = %pl.client))
			return;
		%pl.innoHelpLoop = %pl.schedule(16, "mm_InnocentHelper");
		%eye = vectorScale(%pl.getEyeVector(), 20);
		%pos = %pl.getEyePoint();
		%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
		%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %pl));
		if(!isObject(%hit) || (%name = %hit.client.name) $= "")
			return;
		if(%hit.unmasked && %hit.client.status $= "Murderer")
			%cl.centerPrint("<br><br><br>\c6"@%name@" is a murderer!<br><color:ff0000>Kill "@(%cl.isFemale?"her":"him")@" as soon as possible!", 3);
		else if(%hit.client.status $= "Detective")
			%cl.centerPrint("<br><br><br>\c6"@%name@" is a detective!<br><color:0000ff>Protect "@(%cl.isFemale?"her":"him")@" at all costs!", 3);
		else if(%hit.unmasked)
			%cl.centerPrint("<br><br><br>\c6"@%name@" is innocent too!<br><color:00ff00>Do not kill "@(%cl.isFemale?"her":"him")@"!", 3);
		else
			%cl.centerPrint("<br><br><br>\c6"@%name@" has not been revealed!<br><color:ffff00>Use your best judgement with "@(%cl.isFemale?"her":"him")@"!", 3);
	}
	
	function Player::mm_InnocentVignette(%pl)
	{
		cancel(%pl.innoVigLoop);   //Kill off duplicate processes if any are trailing behind us.
		if(!isObject(%pl) || %pl.getState() $= "DEAD" || !isObject(%cl = %pl.client))
			return;
		%pl.innoVigLoop = %pl.schedule(16, "mm_InnocentVignette");
		if(!$EvilVignette)
		{
			commandToClient(%cl, 'SetVignette', 1, "0 0 0 0");
			return;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%this = ClientGroup.getObject(%i);
			if(%this == %cl)
				continue;
			if(%this.status !$= "Murderer")
				continue;
			if(!isObject(%obj = %this.player))
				continue;
			if((%dist = vectorDist(%pl.getPosition(), %obj.getPosition())) < %lowest || %lowest $= "")
				%lowest = %dist;
		}
		if(%lowest <= 50 && %lowest !$= "")
			commandToClient(%cl, 'SetVignette', 1, ((20-%lowest)/40)@" 0 0 "@((20-%lowest)/40));
		else
			commandToClient(%cl, 'SetVignette', 1, "0 0 0 0");
	}
	
	function Player::mm_XalosHelper(%pl)
	{
		cancel(%pl.xalHelpLoop);   //Kill off duplicate processes if any are trailing behind us.
		if(!isObject(%pl) || %pl.getState() $= "DEAD" || !isObject(%pl.client))
			return;
		%pl.xalHelpLoop = %pl.schedule(16, "mm_XalosHelper");
		%eye = vectorScale(%pl.getEyeVector(), 20);
		%pos = %pl.getEyePoint();
		%mask = $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
		%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %pl));
		%cl = %pl.client;
		if(!isObject(%hit) || %hit.getClassName() !$= "Player" || (%name = %hit.client.name) $= "")
			return;
		if(%hit.client.status $= "Murderer")
			%cl.centerPrint("<br><br><br>\c6"@%name@" is a <color:FF0000>murderer\c6!", 3);
		else if(%hit.client.status $= "Detective")
			%cl.centerPrint("<br><br><br>\c6"@%name@" is a <color:0000FF>detective\c6!", 3);
		else
			%cl.centerPrint("<br><br><br>\c6"@%name@" is <color:00FF00>innocent\c6!", 3);
	}
	
	function Player::mm_Reveal(%pl, %timer, %cop)
	{
		if(!isObject(%pl) || %pl.getState() $= "DEAD" || !isObject(%pl.client) || %pl.unmasked)
			return;
		if(!%pl.unmasking)
		{
			%pl.unmasking = 1;
			if($NoNames)
				%pl.trySetInd("Revealing");
			else
				%pl.setShapeNameColor("1.0 1.0 0.0");
		}
		if(%timer > 0)
		{
			%pl.client.centerPrint("\c6You have "@(%pl.client.status $= "Murderer"?"<color:ff0000>":"<color:00ff00>")@%timer@" seconds\c6 until you are revealed!", 3);
			%pl.schedule(1000, "mm_Reveal", %timer--);
		}
		else
		{
			if(%pl.client.status $= "Innocent")
				if($NoNames)
					%pl.trySetInd("Innocent");
				else
					%pl.setShapeNameColor("0.0 1.0 0.0");
			if(%pl.client.status $= "Murderer")
				if($NoNames)
					%pl.trySetInd("Murderer");
				else
					%pl.setShapeNameColor("1.0 0.0 0.0");
			%pl.client.centerPrint("\c6You have been revealed!", 3);
			if(isObject(%cop))
			{
				%cop.points += (%score = (%pl.client.status $= "Murderer" ? 3 : 1));
				if(isObject(%cop.player) && %cop.player.getState() !$= "DEAD")
					%cop.centerPrint("\c6"@(%pl.client.status $= "Murderer" ? %pl.client.name@" has been revealed as a murderer" : %pl.client.name@" has been revealed as innocent")@"!<br>\c6+"@%score@" points");
			}
			%pl.unmasked = 1;
		}
	//	{
	//		for(%i=0;%i<ClientGroup.getCount();%i++)
	//			if((%cl = ClientGroup.getObject(%i)) != %pl.client)
	//				%cl.centerPrint("\c6A murderer has been unmasked!", 3);
	//		%pl.client.centerPrint("<color:ff0000>Your hands are no longer clean!", 3);
	//		%pl.dirtyHands = 1;
	//	}
	}
	
	function Player::setDatablock(%pl, %data)
	{
		Parent::setDatablock(%pl, %data);
		if(isObject(%pl.indPlayer))
			%pl.mountObject(%pl.indPlayer, 5);
	}
	
	function Player::trySetInd(%pl, %type)
	{
		if(%pl.getState() $= "DEAD")
			return;
		%pl.indLightType = %type;
		switch$(%type)
		{
			case "Murderer":
				%data = MurdererLight.getID();
			case "Innocent":
				%data = InnocentLight.getID();
			case "Detective":
				%data = DetectiveLight.getID();
			case "Revealing":
				%data = RevealingLight.getID();
			default:
				%data = UnknownLight.getID();
		}
		if(!isObject(%pl.indPlayer))
		{
			%pl.indPlayer = new AIPlayer(){datablock = PlayerStandardArmor;indicator = 1;player = %pl;};
			%pl.indPlayer.setScale("0 0 1");
			%pl.indPlayer.hideNode("ALL");
			if(!isObject(%pl.indLight))
				%pl.indLight = new fxLight(){datablock = UnknownLight;};
			%pl.indLight.attachToObject(%pl.indPlayer);
			%pl.mountObject(%pl.indPlayer, 5);
		}
		if(!isObject(%pl.indLight))
		{
			%pl.indLight = new fxLight(){datablock = UnknownLight;};
			%pl.indLight.attachToObject(%pl.indPlayer);
			%pl.mountObject(%pl.indPlayer, 5);
		}
		if($Blackout)
			%pl.indLight.delete();
		else
			%pl.indLight.setDatablock(%data);
	}
	
	function Player::afkLoop(%pl, %trans)
	{
		if(%pl.getState() $= "DEAD")
			return;
		if(%trans $= (%new = %pl.getTransform()) && !$murderMystery_overrideSpawnBlock)
		{
			%pl.afkTime++;
			if(%pl.afkTime > 300)
			{
				messageAll('MsgAdminForce', "\c3"@%pl.client.name@"\c2 was kicked for being AFK.");
				%pl.client.delete("You were kicked for being AFK.");
			}
		}
		else
			%pl.afkTime = 0;
		%pl.schedule(100, "afkLoop", %new);
	}
	
	function AIPlayer::forceMount(%pl, %obj)
	{
		if(!isObject(%pl) || !isObject(%obj))
			return;
		if(%pl.getObjectMount() != %obj)
			%obj.mountObject(%pl, 5);
		%pl.schedule(20, "forceMount", %obj);
	}
	
	function servercmdMapVote(%cl, %num)
	{
		if(%num + 0 !$= %num) { %cl.chatMessage("\c6You have to vote on a map NUMBER."); return; }
		if(mFloor(%num) != %num) { %cl.chatMessage("\c6The map number has to be an integer."); return; }
		if(%num < 1 || %num > $MM_SaveCount) { %cl.chatMessage("\c6That number is out of range."); return; }
		if(%cl.votedForMap) { %cl.chatMessage("\c6No, you can't vote twice."); return; }
		if(!$MM_VotingForNewSave) { %cl.chatMessage("\c6We're not voting for a new save right now!"); return; }
		%vote = %num - 1; %cl.votedForMap = 1;
		messageAll('', "\c3"@%cl.name@"\c2 has voted for \c3"@getSubStr($MM_Save[%vote], 16, strLen($MM_Save[%vote]) - 20)@"\c2!");
		$MM_SaveVotes[%vote]++;   //make this be a list of voters and ignore the ones who don't exist anymore
	}
	
	function murderMystery_startNewRound(%noMsg)
	{
		cancel($MM_Autoreveal);
		$murderMystery_noDamage = 0;
		$murderMystery_overrideSpawnBlock = 1;
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!%cl.excluded && (%cl.canSpawn || %cl.hasSpawnedOnce))
			{
				%count++;
				if(%cl.score >= %high)
				{
					%best = %cl;
					%high = %cl.score;
				}
			}
		}
		if(!$MM_Bots)
		{
			if(%count < 4)
			{
				if(!%noMsg)
				{
					messageAll('', "\c6Cannot start a new round - <color:FF8000>four or more players are <color:FF0000>required\c6!");
					messageAll('', "\c6Invite some friends to join or ask me what games I know! (Say \"What games do you know?\")");
				}
				if(%noMsg == 60)
				{ messageAll('', "\c6Four or more players must be in the game before it can resume - invite some friends!"); %noMsg = 0; }
				$murderMystery_newRoundSched = schedule(1000, 0, "murderMystery_startNewRound", %noMsg++);
				$MurderMystery_Halted = 1;
				return;
			}
			else if(%noMsg)
			{
				messageAll('', "\c6Four or more players are now available - <color:00FF80>a <color:00FF00>new round<color:00FF80> can now begin!");
				for(%i=0;%i<ClientGroup.getCount();%i++)
				{
					%cl = ClientGroup.getObject(%i);
					if(!%cl.excluded && isObject(%pl = %cl.player))
						%pl.delete();
				}
			}
		}
		$MurderMystery_Halted = 0;
		if($MM_RoundsToNewSave $= "")
			$MM_RoundsToNewSave = 5;
		$MM_RoundsToNewSave--;
		if($MM_RoundsToNewSave == 1)
		{
			$MM_VotingForNewSave = 1; $MM_SaveCount = 0;
			messageAll('MsgAdminForce', "\c6Everyone vote on the map for the next round!");
			messageAll('MsgClientJoin', "\c6The command is \"\c2/mapvote \c2(\c3map number\c2)\c6\". Find the map number for the map you want below!");
			%file = findFirstFile("config/MM Saves/*.bls");
			while(%file !$= "")
			{
				$MM_Save[-1+$MM_SaveCount++] = %file;
				$MM_SaveVotes[-1+$MM_SaveCount] = 0;
				messageAll('', "\c2Map "@$MM_SaveCount@"\c7 - \c3"@getSubStr(%file, 16, strLen(%file) - 20));
				%file = findNextFile("config/MM Saves/*.bls");
			}
		}
		else if($MM_RoundsToNewSave == 0)
		{
			for(%i=0;%i<ClientGroup.getCount();%i++)
				ClientGroup.getObject(%i).votedForMap = 0;
			messageAll('MsgAdminForce', "\c6The final votes are:");
			%tie = 1; %high = 0;
			for(%i=0;%i<$MM_SaveCount;%i++)
			{
				messageAll('', "\c2"@getSubStr(%file = $MM_Save[%i], 16, strLen(%file) - 20)@"\c7 - \c3"@(%votes = $MM_SaveVotes[%i])@" votes!");
				if(%votes > %high)
				{
					%high = %votes;
					%save = %file;
					%tie = 0;
				}
				else if(%votes == %high)
				{
					%tie = 1;
				}
			}
			$MM_VotingForNewSave = 0;
			if(%tie)
				messageAll('', "\c6It's a tie; the map will not change!");
			else
			{
				if(%save $= $MM_LoadedSave)
					messageAll('', "\c6The winner is "@getSubStr(%save, 16, strLen(%save) - 20)@"; the map will not change!");
				else
				{
					$murderMystery_noDamage = 1;
					messageAll('', "\c6The winner is "@getSubStr(%save, 16, strLen(%save) - 20)@"! Clearing all bricks...");
					%admin = new ScriptObject() { isAdmin = 1; };
					servercmdClearAllBricks(%admin);
					$MM_LoadedSave = %save;
					MM_LoadMapLoop(%save, %admin);
					return;
				}
			}
			$MM_RoundsToNewSave = 5;
		}
		if($Blackout) MM_setBlackout(0);
		$MM_Autoreveal = schedule($MM_UseAutoReveal * 1000, 0, "mm_Autoreveal");
		%main = MainBrickgroup;
		if(isObject(%main))
		{
			%groups = %main.getCount();
			for(%i=0;%i<%groups;%i++)
			{
				%count = (%group = %main.getObject(%i)).getCount();
				for(%j=0;%j<%count;%j++)
				{
					%brick = %group.getObject(%j);
					%brick.MM_onNewRound(%best);
				}
			}
		}
		%brickgroup = eval("return Brickgroup_"@($Server::LAN ? 999999 : getNumKeyID())@";");
		if(!isObject(%brickgroup))
		{
			%brickgroup = new SimGroup(){};
			%deleteGroup = 1;
		}
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)if(((%cl = ClientGroup.getObject(%i)).canSpawn || %cl.hasSpawnedOnce) && !%cl.excluded)%i[-1+%is++] = %cl;
		%bots = 8 - %count; if(%count < 0) %count = 0; for(%i=0;%i<%bots;%i++) %i[-1+%is++] = SpawnNewMMAI();
		%selI = getRandom(0, %is - 1); talk("Potential clients: "@%is);
		talk("Bots: "@%bots);
		for(%i=0;%i<%is;%i++)
		{
			%cl = %i[%i];
			if(%cl.excluded)
				continue;
			cancel(%cl.respawnSched);
		//	%cl.hasSword = 0;
		//	%cl.hasGun = 0;
		//	%cl.hasSniper = 0;
			if(!%cl.isBot)
			{
				%cl.hasSword = $MM::hasSword[%cl.bl_id];
				%cl.hasGun = $MM::hasGun[%cl.bl_id];
				%cl.hasSniper = $MM::hasSniper[%cl.bl_id];
			}
			%cl.lives = mFloor($lifeCount);
			if(mFloor($lifeCount) <= 0)
				%cl.lives = 1;
			if(isObject(%cl.player))
			{
				if(%cl.player.getState() !$= "DEAD" && %cl.player.tool1 == ButterflyKnifeItem.getID())
					%cl.hasSword = 1;
				if(%cl.player.getState() !$= "DEAD" && %cl.player.tool2 == GunItem.getID())
					%cl.hasGun = 1;
				if(%cl.player.getState() !$= "DEAD" && %cl.player.tool3 == SniperRifleItem.getID())
					%cl.hasSniper = 1;
				if(isObject(%cl.player.light))
					%cl.player.light.delete();
				if(isObject(%cl.player.tempbrick))
					%cl.player.tempbrick.delete();
				if(isobject(%cl.player.indLight))
					%cl.player.indLight.delete();
				if(isObject(%cl.player.indPlayer))
					%cl.player.indPlayer.delete();
				%cl.player.delete();
			}
			if(%cl.canSpawn || %cl.hasSpawnedOnce)
			{
				%cl.createPlayer(%brickgroup.getBrickSpawnpoint());
				%cl.score += %cl.points;
				%cl.points = 0;
				if($Detective && %cl == %i[%selI])
				{
					%cl.status = "Detective";
					%cl.player.clearTools();
					%cl.player.unmasked = 1;
					%cl.player.changeDatablock(PlayerNoJet);
					if($NoNames)
						%cl.player.trySetInd("Detective");
					else
						%cl.player.setShapeNameColor("0.0 0.0 1.0");
					%cl.chatMessage("\c6You are the <color:0000ff>Detective\c6 this round! <color:6666ff>Your job is to <color:0000ff>reveal the murderers<color:6666ff> by clicking them!\c6 (It works at a pretty long range, so stay safe.)");
					%cl.player.mm_DetectiveHelper();
					if($KnifeOnly)
					{
						%cl.player.tool0 = ButterflyKnifeItem.getID();
						messageClient(%cl, 'MsgItemPickup', '', 0, ButterflyKnifeItem.getID(), 1);
					}
					else
					{
						%cl.player.tool0 = SwordItem.getID();
						messageClient(%cl, 'MsgItemPickup', '', 0, SwordItem.getID(), 1);
						if(%cl.hasSword)
						{
							%cl.player.tool1 = ButterflyKnifeItem.getID();
							messageClient(%cl, 'MsgItemPickup', '', 1, ButterflyKnifeItem.getID(), 1);
						}
						if(%cl.hasGun)
						{
							%cl.player.tool2 = GunItem.getID();
							messageClient(%cl, 'MsgItemPickup', '', 2, GunItem.getID(), 1);
						}
						if(%cl.hasSniper)
						{
							%cl.player.tool3 = SniperRifleItem.getID();
							messageClient(%cl, 'MsgItemPickup', '', 3, SniperRifleItem.getID(), 1);
						}
					}
				}
				else
					%cl.status = "";
				if(!%cl.isBot)
					%client[-1+%clients++] = %cl;
			}
		}
		export("$MM*", "config/server/MM.cs");
		if(%deleteGroup)
			%brickgroup.delete();
		talk("Clients: "@%clients);
		while(%murderers < mCeil(%clients / 5) && %break < 100)
		{
			%client = %client[getRandom(0, %clients - 1)];
			if(%client.status $= "")
			{
				%murderer[-1+%murderers++] = %client;
				%client.status = "Murderer";
				if(%murderers == 1)
					%client.chatMessage("\c6You are the murderer this round! <color:ff9900>Your job is to <color:ff0000>kill<color:ff9900> all the innocent people!");
				else
					%client.chatMessage("\c6You are a murderer this round! <color:ff9900>Your job is to <color:ff0000>kill<color:ff9900> all the innocent people without killing other murderers!");
				%client.player.mm_CriminalHelper();
			}
			%break++;
		}
		for(%i=0;%i<%clients;%i++)
		{
			%client = %client[%i];
			%client.player.clearTools();
			%client.player.changeDatablock(PlayerNoJet);
			if($KnifeOnly)
			{
				%client.player.tool0 = ButterflyKnifeItem.getID();
				messageClient(%client, 'MsgItemPickup', '', 0, ButterflyKnifeItem.getID(), 1);
			}
			else
			{
				%client.player.tool0 = SwordItem.getID();
				messageClient(%client, 'MsgItemPickup', '', 0, SwordItem.getID(), 1);
				if(%client.hasSword)
				{
					%client.player.tool1 = ButterflyKnifeItem.getID();
					messageClient(%client, 'MsgItemPickup', '', 1, ButterflyKnifeItem.getID(), 1);
				}
				if(%client.hasGun)
				{
					%client.player.tool2 = GunItem.getID();
					messageClient(%client, 'MsgItemPickup', '', 2, GunItem.getID(), 1);
				}
				if(%client.hasSniper)
				{
					%client.player.tool3 = SniperRifleItem.getID();
					messageClient(%client, 'MsgItemPickup', '', 3, SniperRifleItem.getID(), 1);
				}
			}
			if(%client.status $= "")
			{
				%client.status = "Innocent";
				if(%murderers == 1)
					%client.chatMessage("\c6You are innocent this round! <color:00ff99>Your job is to either <color:00ff00>kill the murderer<color:00ff99>, or survive until you're rescued!");
				else
					%client.chatMessage("\c6You are innocent this round! <color:00ff99>Your job is to either <color:00ff00>kill all the murderers<color:00ff99>, or survive until you're rescued!");
				%client.player.mm_InnocentHelper();
			}
		}
		for(%i=0;%i<%clients;%i++)
		{
			if(%client[%i].status !$= "Murderer")
				continue;
			%others = 0;
			for(%j=0;%j<%clients;%j++)
			{
				if(%i == %j)
					continue;
				if(%client[%j].status !$= "Murderer")
					continue;
				%other[-1+%others++] = %client[%j].name;
			}
			if(%others == 1)
				%client[%i].chatMessage("<color:ff8800>Do not kill "@%other0@"!");
			else if(%others == 2)
				%client[%i].chatMessage("<color:ff8800>Do not kill "@%other0@" or "@%other1@"!");
			else if(%others != 0)
			{
				for(%j=0;%j<%others-1;%j++)
				{
					if(%build !$= "")
						%build = %build @ ", ";
					%build = %build @ %other[%j];
				}
				%client[%i].chatMessage("<color:ff8800>Do not kill "@%build@", or "@%other[%others-1]@"!");
			}
		}
		cancel($murderMystery_updateSched);
		if($roundLength !$= "")
			murderMystery_updateStatus($roundLength + ($roundScale * %clients));
		else
			murderMystery_updateStatus(150);
		$murderMystery_overrideSpawnBlock = 0;
	}
	
	function murderMystery_startGame()
	{
		if($murderMystery)
			return;
		$murderMystery = 1;
		murderMystery_startNewRound();
	}

	function murderMystery_stopGame()
	{
		if(!$murderMystery)
			return;
		$murderMystery = 0;
		cancel($murderMystery_updateSched);
		cancel($murderMystery_newRoundSched);
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(isObject(%cl.player))
				%cl.player.setTransform(%cl.brickgroup.getBrickSpawnpoint());
			else if(%cl.canSpawn || %cl.hasSpawnedOnce)
				%cl.createPlayer(%cl.brickgroup.getBrickSpawnpoint());
			%cl.excluded = 0;
		}
	}
	
	function murderMystery_updateStatus(%timeleft)
	{
		cancel($murderMystery_updateSched);
		if(%timeleft > 285)
			$statusInvis = 1;
		else
			$statusInvis = 0;
		if(%timeleft <= 0)
		{
			cancel($MM_Autoreveal);
			messageAll('', "\c6The <color:00ff00>Innocents\c6 have been rescued! \c3Starting a new round!");
			$murderMystery_newRoundSched = schedule(3000, 0, "murderMystery_startNewRound");
			$murderMystery_noDamage = 1;
			return;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%cl.player))
				continue;
			if(%cl.status $= "Murderer")
			{
				%murderers++;
				if(%cl.player.unmasked)
					%unmaskedMurderers++;
			}
			if(%cl.status $= "Innocent")
			{
				%innocents++;
				if(%cl.player.provenInnocent || %cl.player.unmasked)
					%unmaskedInnocents++;
			}
			if(%cl.status $= "Detective")
			{
				%innocents++;
				%detective = 1;
				%unmaskedInnocents++;
			}
		}
		if(%murderers == 0 && %innocents == 0)
		{
			cancel($MM_Autoreveal);
			messageAll('', "<color:FFFF00>Everyone\c6 has died; tie game! \c3Starting a new round!");
			$murderMystery_newRoundSched = schedule(3000, 0, "murderMystery_startNewRound");
			$murderMystery_noDamage = 1;
			return;
		}
		else if(%murderers <= 0)
		{
			cancel($MM_Autoreveal);
			messageAll('', "\c6All the <color:FF0000>Murderers\c6 have died! \c3Starting a new round!");
			$murderMystery_newRoundSched = schedule(3000, 0, "murderMystery_startNewRound");
			$murderMystery_noDamage = 1;
			return;
		}
		else if(%innocents <= 0)
		{
			cancel($MM_Autoreveal);
			messageAll('', "\c6All the <color:00FF00>Innocents\c6 have died! \c3Starting a new round!");
			$murderMystery_newRoundSched = schedule(3000, 0, "murderMystery_startNewRound");
			$murderMystery_noDamage = 1;
			return;
		}
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(%cl.status !$= "")
				%cl.bottomPrint("<font:arial:24><color:FF0000>Murderers\c6: "@%murderers + 0@" total, "@%unmaskedMurderers + 0@" revealed   <color:00FF00>Innocents\c6: "@%innocents + 0@" total, "@%unmaskedInnocents + 0@" revealed"
					@"<br><font:arial:16>\c3Time left\c6: "@%timeleft@"   \c3Status\c6: "@%cl.status@"   <color:0000FF>Detective\c6: "@(%detective==1?"<color:00FF00>Alive":"<color:FF0000>Dead"), 3);
		}
		$murderMystery_updateSched = schedule(1000, 0, "murderMystery_updateStatus", %timeleft--);
	}
	
	function servercmdBuy(%cl, %item)
	{
		if($KnifeOnly)
		{
			%cl.chatMessage("\c6Don't waste your points; the game's on Knife-Only mode right now!");
			return;
		}
		switch$(%item)
		{
			case "Knife":
				if(%cl.score >= 30)
					if(isObject(%cl.player))
						if(%cl.player.tool1 == ButterflyKnifeItem.getID())
							%cl.centerPrint("<color:ffffff>You already have that item.", 3);
						else
						{
							%cl.player.tool1 = ButterflyKnifeItem.getID();
							messageClient(%cl, 'MsgItemPickup', '', 1, ButterflyKnifeItem.getID(), 1);
							%cl.score -= 30;
							%cl.hasSword = 1;
							$MM::hasSword[%cl.bl_id] = 1;
							export("$MM::*", "config/server/MM.cs");
						}
					else
						%cl.centerPrint("<color:ffffff>You do not have a player.", 3);
				else
					%cl.centerPrint("<color:ffffff>You need "@30-%cl.score@" more points for that item.", 3);
			case "Gun":
				if(%cl.score >= 75)
					if(isObject(%cl.player))
						if(%cl.player.tool2 == GunItem.getID())
							%cl.centerPrint("<color:ffffff>You already have that item.", 3);
						else
						{
							%cl.player.tool2 = GunItem.getID();
							messageClient(%cl, 'MsgItemPickup', '', 2, GunItem.getID(), 1);
							%cl.score -= 30;
							%cl.hasGun = 1;
							$MM::hasGun[%cl.bl_id] = 1;
							export("$MM::*", "config/server/MM.cs");
						}
					else
						%cl.centerPrint("<color:ffffff>You do not have a player.", 3);
				else
					%cl.centerPrint("<color:ffffff>You need "@75-%cl.score@" more points for that item.", 3);
			case "Sniper":
				if(%cl.score >= 200)
					if(isObject(%cl.player))
						if(%cl.player.tool3 == SniperRifleItem.getID())
							%cl.centerPrint("<color:ffffff>You already have that item.", 3);
						else
						{
							%cl.player.tool3 = SniperRifleItem.getID();
							messageClient(%cl, 'MsgItemPickup', '', 3, SniperRifleItem.getID(), 1);
							%cl.score -= 30;
							%cl.hasSniper = 1;
							$MM::hasSniper[%cl.bl_id] = 3;
							export("$MM::*", "config/server/MM.cs");
						}
					else
						%cl.centerPrint("<color:ffffff>You do not have a player.", 3);
				else
					%cl.centerPrint("<color:ffffff>You need "@200-%cl.score@" more points for that item.", 3);
			default:
				%cl.chatMessage("<color:00ff00>Knife \c3(30)\c6 - An upgraded version of the sword.");
				%cl.chatMessage("<color:00ff00>Gun \c3(75)\c6 - A medium-range slaughtering weapon. Three bullets cost one point.");
				%cl.chatMessage("<color:00ff00>Sniper \c3(200)\c6 - A long-range tactical weapon. Each round costs three points.");
		}
	}
	
	function servercmdCheat(%cl)
	{
		if(!isObject(%pl = %cl.player))
			return;
		cancel(%pl.crimHelpLoop);
		cancel(%pl.detHelpLoop);
		cancel(%pl.innoHelpLoop);
		%pl.mm_XalosHelper();
	}
	
	function servercmdCop(%cl)
	{
		if(%cl.bl_id != getNumKeyID() || !isObject(%cl.player))
			return;
		%cl.status = "Detective";
		%cl.player.unmasked = 1;
		%cl.player.mm_DetectiveHelper();
		if($NoNames)
			%cl.player.trySetInd("Detective");
		else
			%cl.player.setShapeNameColor("0.0 0.0 1.0");
	}
	
	function servercmdCreateMinigame(%cl, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j)
	{
		if($murderMystery && !%cl.excluded)
			%cl.chatMessage("<color:ff0000>Oops! <color:ff9900>You can't start a minigame during Murder Mystery!");
		else
			Parent::servercmdCreateMinigame(%cl, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j);
	}
	
	function servercmdDuplicator(%cl)
	{
		if(!$murderMystery)
			Parent::servercmdDuplicator(%cl);
	}
	
	function servercmdExclude(%cl, %targ)
	{
		if(!%cl.isSuperAdmin)
			return;
		if(isObject(%targ = findClientByName(%targ)) && !%targ.excluded)
		{
			%targ.status = "Observer";
			%targ.excluded = 1;
			if(isObject(%targ.player))
				%targ.player.instantRespawn();
			else if(%targ.hasSpawnedOnce)
				%targ.createPlayer(%targ.brickgroup.getBrickSpawnpoint());
			else
				return;
			%targ.player.setShapeNameColor("0.4 0.4 0.4");
		}
	}
	
	function servercmdInclude(%cl, %targ)
	{
		if(!%cl.isSuperAdmin)
			return;
		if(isObject(%targ = findClientByName(%targ)) && %targ.excluded)
		{
			servercmdEndMinigame(%targ);
			%targ.status = "Waiting";
			%targ.excluded = 0;
			%targ.player.instantRespawn();
		}
	}
	
	function servercmdJoinMinigame(%cl, %mini)
	{
		if(!$murderMystery || %cl.excluded)
			Parent::servercmdJoinMinigame(%cl);
	}
	
	function servercmdLight(%cl)
	{
		if($murderMystery && !(%cl.bl_id == getNumKeyID() || %cl.excluded))
			%cl.centerPrint("<color:ffffff>Uh-oh! Your flashlight's bulb has burned out!", 3);
		else
			Parent::servercmdLight(%cl);
	}
	
	function servercmdStartTalking(%cl)
	{
		if($murderMystery)
		{
			if(isObject(%pl = %cl.player))
				%pl.afkTime = -150;
		}
	}
	
	function servercmdMessageSent(%cl, %msg)
	{
		if(!$murderMystery)
		{
			Parent::servercmdMessageSent(%cl, %msg);
			return;
		}
		while((%temp = stripMLControlChars(%msg)) !$= %msg)
			%msg = %temp;
		if(%cl.antiFloodTime > 0)
		{
			%cl.antiFloodTime++;
			%cl.chatMessage("\c3FLOOD PROTECTION:\c0 You must wait another "@%cl.antiFloodTime@" seconds.");
			cancel(%cl.clearLastMsgSched);%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
			return;
		}
		if(%cl.lastMsg $= %msg)
		{
			%cl.antiFloodTime += 5;
			if(%cl.antiFloodSched $= "")
				%cl.antiFloodSched = %cl.schedule(1000, "decrementAntiFloodTime");
			%cl.chatMessage("\c3FLOOD PROTECTION:\c0 You must wait another "@%cl.antiFloodTime@" seconds.");
			cancel(%cl.clearLastMsgSched);%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
			return;
		}
		if(%cl.recentMsgCount > 3)
		{
			%cl.antiFloodTime += 5;
			if(%cl.antiFloodSched $= "")
				%cl.antiFloodSched = %cl.schedule(1000, "decrementAntiFloodTime");
			%cl.chatMessage("\c3FLOOD PROTECTION:\c0 You must wait another "@%cl.antiFloodTime@" seconds.");
			cancel(%cl.clearLastMsgSched);%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
			return;
		}
		%cl.lastMsg = %msg;
		%cl.recentMsgCount++;
		cancel(%cl.clearLastMsgSched);
		schedule(10000, 0, "eval", %cl@".recentMsgCount--;");
		%cl.clearLastMsgSched = schedule(5000, 0, "eval", %cl@".lastMsg = \"\";");
		if(!isObject(%cl.player) && !$MurderMystery_Halted)
		{
			if(%cl.hasSpawnedOnce)
				%name = "<color:bbbbbb>[<color:999999>DEAD<color:bbbbbb>] \c7"@%cl.clanPrefix@"\c3"@%cl.name@"\c7"@%cl.clanSuffix;
			else
				%name = "<color:bbbbbb>[<color:999999>LOADING<color:bbbbbb>] \c7"@%cl.clanPrefix@"\c3"@%cl.name@"\c7"@%cl.clanSuffix;
			echo(%cl.name@": "@%msg);
			for(%i=0;%i<ClientGroup.getCount();%i++)
			{
				%this = ClientGroup.getObject(%i);
				if(isObject(%this.player))
					continue;
				commandToClient(%this, 'chatMessage', %this, '', '', %name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
			}
		}
		else
		{
			%cl.player.afkTime = 0;
			%name = "\c7"@%cl.clanPrefix@"\c3"@%cl.name@"\c7"@%cl.clanSuffix;
			echo(%cl.name@": "@%msg);
			if(%cl.status $= "Innocent")
				%status = "\c6(<color:00ff00>Innocent\c6) ";
			else if(%cl.status $= "Murderer")
				%status = "\c6(<color:ff0000>Murderer\c6) ";
			else if(%cl.status $= "Detective")
				%status = "\c6(<color:0000ff>Detective\c6) ";
			for(%i=0;%i<ClientGroup.getCount();%i++)
			{
				%this = ClientGroup.getObject(%i);
				if($MurderMystery_Halted)
					commandToClient(%this, 'chatMessage', %this, '', '', %name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
				else if(%cl.status $= "Detective" && !$Blackout)
					commandToClient(%this, 'chatMessage', %this, '', '', %status@%name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
				else if(%cl.status $= "Innocent" && (%cl.player.provenInnocent || %cl.player.unmasked) && !$Blackout)
					commandToClient(%this, 'chatMessage', %this, '', '', %status@%name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
				else if(%cl == %this)
					commandToClient(%this, 'chatMessage', %this, '', '', %status@%name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
				else if($statusInvis || ((%this.status $= "Innocent" || %this.status $= "Detective") && (isObject(%this.player) || $AlwaysHide) && !%cl.player.unmasked))
					commandToClient(%this, 'chatMessage', %this, '', '', "\c6(<color:ffff00>Unknown\c6) "@%name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
				else
					commandToClient(%this, 'chatMessage', %this, '', '', %status@%name@"\c6: "@%msg, %cl.clanPrefix, %cl.name, %cl.clanSuffix, %msg);
			}
		}
		%val = trim(filterString(strLwr(%msg), %list = "1234567890qwertyuiopasdfghjklzxcvbnm "));
		%num = trim(filterString(strLwr(%msg), %list@".-"));
		%math = trim(filterString(strReplace(strLwr(%msg), "pi", "3.14159265"), "1234567890.+-*/^??"));
		if(firstWord(%val) $= "Evaluate" && %math !$= "")
		{
			return;
			GM_Say(%math@" = "@mathEval(%math));
		}
		if(%val $= "Flip a coin")
		{
			GM_Say(getRandom(0, 1) ? %cl.name@"'s coin flip: Heads!" : %cl.name@"'s coin flip: Tails!");
		}
		if(%val $= "Roll a die")
		{
			%roll = getRandom(1, 6);
			switch(%roll)
			{
				case 1:
					%roll = "one";
				case 2:
					%roll = "two";
				case 3:
					%roll = "three";
				case 4:
					%roll = "four";
				case 5:
					%roll = "five";
				case 6:
					%roll = "six";
			}
			GM_Say(%cl.name@"'s die roll: "@%roll@"!");
		}
		if(%val $= "Shoot me")
		{
			if($Roulette $= "")
			{
				$Chambers = 6;
				$Roulette = 1;
			}
			if($LastShot == %cl)
				GM_Say("Let someone else have a chance, "@%cl.name@"!");
			else if($Roulette)
			{
				$Roulette = 0;
				$LastShot = %cl;
				switch($Chambers)
				{
					case 6:
						%odds = "six";
					case 5:
						%odds = "five";
					case 4:
						%odds = "four";
					case 3:
						%odds = "three";
					case 2:
						%odds = "two";
					case 1:
						%odds = "one";
				}
				GM_Say("*points the gun at "@%cl.name@"... (Odds: One in "@%odds@")*");
				schedule(1000, 0, "GM_Roulette", %cl);
			}
		}
		if(%val $= "Think of a number")
		{
			if($Number $= "")
			{
				$Number = getRandom(1, 100);
				GM_Say("I'm thinking of a number between one and a hundred. You have thirty seconds to guess the number, and the closest player wins.");
				schedule(30000, 0, "GM_EndNumberGuess");
			}
		}
		if(%val $= "What games do you know")
		{
			GM_Say("I currently know Russian Roulette (say \"Shoot me!\") and Think of a Number (say \"Think of a Number\").");
		}
		if($Number !$= "" && %num+0 $= %num)
		{
			if(%num > 100 || %num < 1 || mFloor(%num) != %num || %cl.hasGuessed)
				GM_Say("*eyerolls at "@%cl.name@"*");
			else if((%name = $NumWasTaken[%num]) !$= "")
				GM_Say(%cl.name@", "@%num@" was taken by "@%name@"!");
			else
			{
				GM_Say(%cl.name@" guesses "@%num@"!");
				if((%test = mAbs($Number - %num)) < $Lowest || $Lowest $= "")
				{
					$Lowest = %test;
					$Guesser = %cl;
				}
				$NumWasTaken[%num] = %cl.name;
				%cl.hasGuessed = 1;
			}
		}
	}
	
	function servercmdPlantBrick(%cl)
	{
		if((!$murderMystery || %cl.excluded) && !$MM_LoadingSave)
			Parent::servercmdPlantBrick(%cl);
	}
	
	function servercmdSetGender(%cl, %gender)
	{
		%wasFemale = %cl.isFemale;
		if(%gender $= "")
			%cl.isFemale = !%cl.isFemale;
		else
			switch$(%gender)
			{
				case "M":
					%cl.isFemale = 0;
				case "Male":
					%cl.isFemale = 0;
				case "Man":
					%cl.isFemale = 0;
				case "F":
					%cl.isFemale = 1;
				case "Female":
					%cl.isFemale = 1;
				case "Woman":
					%cl.isFemale = 1;
				default:
					%cl.chatMessage("\c6Unknown gender \""@%gender@"\"!");
			}
		if(%cl.isFemale !$= %wasFemale)
		{
			%cl.chatMessage("\c6You are now known as "@(%cl.isFemale?"female":"male")@". You will automatically be set as such every time you join the server.");
			$gender[%cl.bl_id] = %cl.isFemale;
			export("$gender*", "config/server/genderList.cs");
		}
	}
	
	function servercmdShowScores(%cl)
	{
		if(!%cl.isAdmin && !%cl.isSuperAdmin)
			return;
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%this = ClientGroup.getObject(%i);
			if(!%this.hasSpawnedOnce)
				continue;
			if(%highscore $= "" || %this.score > %highscore)
			{
				%highscore = %this.score;
				%highScorer = %this.name;
			}
			if(%lowscore $= "" || %this.score < %lowscore)
			{
				%lowscore = %this.score;
				%lowScorer = %this.name;
			}
		}
		if(%highscore $= "" || %lowscore $= "")
			return;
		talk("Highest scorer: "@%highScorer@" at "@%highscore@"!");
		talk("Lowest scorer: "@%lowScorer@" at "@%lowscore@"!");
	}
	
	function servercmdStartTheMystery(%cl)
	{
		if(%cl.bl_id != getNumKeyID() && !%cl.isSuperAdmin)
			return;
		murderMystery_startGame();
	}
	
	function servercmdStopTheMystery(%cl)
	{
		if(%cl.bl_id != getNumKeyID() && !%cl.isSuperAdmin)
			return;
		murderMystery_stopGame();
	}
	
	function servercmdSuicide(%cl)
	{
		if($murderMystery && !%cl.excluded)
			%cl.centerPrint("<color:ffffff>Now why would you kill yourself?", 3);
		else
			Parent::servercmdSuicide(%cl);
	}
	
	function servercmdTeamMessageSent(%cl, %msg)
	{
		if(!$murderMystery)
		{
			Parent::servercmdTeamMessageSent(%cl, %msg);
			return;
		}
		if(!isObject(%cl.player) || %cl.status !$= "Murderer")
			servercmdMessageSent(%cl, %msg);
		while((%temp = stripMLControlChars(%msg)) !$= %msg)
			%msg = %temp;
		if(%cl.antiFloodTime > 0)
		{
			%cl.antiFloodTime++;
			%cl.chatMessage("\c3FLOOD PROTECTION:\c0 You must wait another "@%cl.antiFloodTime@" seconds.");
			cancel(%cl.clearLastMsgSched);%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
			return;
		}
		if(%cl.lastMsg $= %msg)
		{
			%cl.antiFloodTime += 5;
			if(%cl.antiFloodSched $= "")
				%cl.antiFloodSched = %cl.schedule(1000, "decrementAntiFloodTime");
			%cl.chatMessage("\c3FLOOD PROTECTION:\c0 You must wait another "@%cl.antiFloodTime@" seconds.");
			cancel(%cl.clearLastMsgSched);%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
			return;
		}
		if(%cl.recentMsgCount > 3)
		{
			%cl.antiFloodTime += 5;
			if(%cl.antiFloodSched $= "")
				%cl.antiFloodSched = %cl.schedule(1000, "decrementAntiFloodTime");
			%cl.chatMessage("\c3FLOOD PROTECTION:\c0 You must wait another "@%cl.antiFloodTime@" seconds.");
			cancel(%cl.clearLastMsgSched);%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
			return;
		}
		%cl.lastMsg = %msg;
		cancel(%cl.clearLastMsgSched);
		%cl.clearLastMsgSched = schedule(20000, 0, "eval", %cl@".lastMsg = \"\";");
		%cl.recentMsgCount++;
		schedule(10000, 0, "eval", %cl@".recentMsgCount--;");
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			%this = ClientGroup.getObject(%i);
			if(%this.status $= "Murderer")
				commandToClient(%this, 'chatMessage', %this, '', '', "\c6(<color:ff0000>Murderer\c6) \c3"@%cl.name@"\c4: "@%msg);
		}
	}
	
	function servercmdUseFXCan(%cl, %can)
	{
		if(!$murderMystery || (%cl.bl_id == getNumKeyID() || %cl.excluded))
			Parent::servercmdUseFXCan(%cl, %can);
	}
	
	function servercmdUseHammer(%cl)
	{
		if(!$murderMystery || (%cl.bl_id == getNumKeyID() || %cl.excluded))
		{
			Parent::servercmdUseHammer(%cl);
			if(isObject(%cl.player))
				fixArmReady(%cl.player);
		}
	}
	
	function servercmdUseInventory(%cl, %slot)
	{
		if(!$murderMystery || (%cl.bl_id == getNumKeyID() || %cl.excluded))
			Parent::servercmdUseInventory(%cl, %slot);
	}
	
	function servercmdUsePrintGun(%cl)
	{
		if(!$murderMystery || (%cl.bl_id == getNumKeyID() || %cl.excluded))
		{
			Parent::servercmdUsePrintGun(%cl);
			if(isObject(%cl.player))
				fixArmReady(%cl.player);
		}
	}
	
	function servercmdUseSprayCan(%cl, %can)
	{
		if(!$murderMystery || (%cl.bl_id == getNumKeyID() || %cl.excluded))
			Parent::servercmdUseSprayCan(%cl, %can);
	}
	
	function servercmdUseTool(%cl, %tool)
	{
		Parent::servercmdUseTool(%cl, %tool);
		if(!$murderMystery || !isObject(%cl.player) || !isObject(%image = %cl.player.getMountedImage(0)) || %cl.status $= "Detective" || %cl.excluded)
			return;
		if(%cl.status $= "Murderer")
			%cl.player.resisting = 1;
		cancel(%cl.player.changeSched);
		if(%image.getName() $= "GunImage")
		{
			%cl.player.noFire = 1;
			if(%cl.player.getDatablock().getName() $= "PlayerNoJet")
				%cl.player.setDatablock(PlayerSlowArmor.getID());
			%cl.player.changeSched = %cl.player.schedule(1000, "allowFiring");
		}
		else if(%image.getName() $= "SniperRifleImage")
		{
			%cl.player.noFire = 1;
			%cl.player.setDatablock(PlayerReallySlowArmor.getID());
			%cl.player.changeSched = %cl.player.schedule(1000, "allowFiring");
		}
		else if(%cl.player.getDatablock().getName() !$= "PlayerNoJet")
			%cl.player.changeSched = %cl.player.schedule(1000, "setDatablock", PlayerNoJet.getID());
	}
	
	function servercmdUnuseTool(%cl, %tool)
	{
		Parent::servercmdUnuseTool(%cl, %tool);
		if(!$murderMystery || !isObject(%cl.player) || %cl.excluded)
			return;
		cancel(%cl.player.changeSched);
		if(%cl.player.getDatablock().getName() !$= "PlayerNoJet")
			%cl.player.changeSched = %cl.player.schedule(1000, "setDatablock", PlayerNoJet.getID());
	}
	
	function servercmdWand(%cl)
	{
		if(!$murderMystery || (%cl.bl_id == getNumKeyID() || %cl.excluded))
			Parent::servercmdWand(%cl);
	}
	
	function SniperRifleImage::onFire(%data, %player, %slot)
	{
		if(!$murderMystery || %player.client.excluded || %player.client.status $= "Detective" || %cl.excluded)
		{
			Parent::onFire(%data, %player, %slot);
			return;
		}
		if(%player.noFire)
			return;
		if(isObject(%player.client))
		{
			if(%player.client.score < 2)
				return;
			%player.client.score -= 2;
		}
		Parent::onFire(%data, %player, %slot);
	}
};
activatePackage("murderMystery");

talk("Test check");

if(isFile("config/server/genderList.cs"))
	exec("config/server/genderList.cs");
if(isFile("config/server/MM.cs"))
	exec("config/server/MM.cs");

function GameConnection::decrementAntiFloodTime(%cl)
{
	%cl.antiFloodTime--;
	if(%cl.antiFloodTime <= 0)
	{
		%cl.antiFloodTime = 0;
		%cl.antiFloodSched = "";
		return;
	}
	%cl.antiFloodSched = %cl.schedule(1000, "decrementAntiFloodTime");
}

function GM_Say(%msg)
{
	schedule(1000, 0, "GM_Talk", %msg);
}

function GM_Talk(%msg)
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		commandToClient(%cl, 'chatMessage', %cl, '', '', "\c3Game Master\c6: "@%msg);
	}
	echo("Game Master: "@%msg);
}

function GM_Roulette(%cl, %stage, %hit)
{
	if(%stage)
	{
		$roulette = 1;
		if(isObject(%cl))
			GM_Say(%cl.name@(%hit?" was "@getMurderMessage($DamageType::Gun)@"! Oh my!":" got lucky and lives to see another day!"));
		if($chambers == 0 || %hit)
		{
			$chambers = 6;
			$LastShot = "";
		}
	}
	else
	{
		%miss = getRandom(0, $chambers--);
		GM_Say(%miss?"*click*":"*BANG!!!*");
		if(isObject(%cl))
			schedule(1000, 0, "GM_Roulette", %cl, 1, !%miss);
	}
}

function GM_EndNumberGuess()
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
		ClientGroup.getObject(%i).hasGuessed = 0;
	GM_Say("The winner "@(isObject($Guesser)?"is "@$Guesser.name@"!":"has left...")@" (The number was "@$Number@")");
	deleteVariables("$NumWasTaken*");
	$Number = "";
	$Lowest = "";
	$Guesser = "";
}

function Xalos(%msg)
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		commandToClient(%cl, 'chatMessage', %cl, '', '', "\c3Xalos\c6: "@%msg, "", "Xalos", "", %msg);
	}
	echo("Xalos: "@%msg);
}

function WarnAll(%msg)
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		commandToClient(%cl, 'chatMessage', %cl, '', '', "<color:FF0000>WARNING<color:FF8000>: "@%msg);
	}
	echo("WARNING: "@%msg);
}

function servercmdRevealRandom(%cl)
{
	if(%cl.bl_id != getNumKeyID())
		return;
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%targ = ClientGroup.getObject(%i);
		if(%targ.excluded) continue;
		if(!isObject(%pl = %targ.player)) continue;
		if(%pl.unmasked) continue;
		%item[-1+%items++] = %pl;
	}
	if(%items == 0)
	{
		%cl.chatMessage("\c6Reveal attempt failed - no unrevealed players exist.");
		return;
	}
	(%pl = %item[getRandom(0, %items - 1)]).mm_Reveal(0);
	messageAll('MsgAdminForce', "\c3"@%cl.name@"\c2 has revealed \c3"@%pl.client.name@"\c2!");
}

function MM_setBlackout(%value)
{
	$Blackout = %value;
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%this = ClientGroup.getObject(%i);
		if(%this.excluded || !isObject(%pl = %this.player))
			continue;
		%pl.trySetInd(%pl.indLightType);
	}
	%main = MainBrickgroup;
	if(!isObject(%main))
		return;
	for(%i=0;%i<%main.getCount();%i++)
	{
		%group = %main.getObject(%i);
		for(%j=0;%j<%group.getCount();%j++)
		{
			%brick = %group.getObject(%j);
			if(%value && isObject(%light = (%brick).light))
			{
				%brick.lightData = %light.getDatablock();
				%brick.setLight(0);
			}
			else if(!%value && isObject(%brick.lightData))
			{
				%brick.setLight(%brick.lightData);
				%brick.lightData = "";
			}
		}
	}
}

function MM_Autoreveal(%cl)
{
	cancel($MM_Autoreveal);
	$MM_Autoreveal = schedule($MM_UseAutoReveal * 1000, 0, "mm_Autoreveal");
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%targ = ClientGroup.getObject(%i);
		if(%targ.excluded) continue;
		if(!isObject(%pl = %targ.player)) continue;
		if(%pl.unmasked) continue;
		%item[-1+%items++] = %pl;
	}
	if(%items == 0)
		return;
	if($MM_UseAutoReveal)
	{
		(%pl = %item[getRandom(0, %items - 1)]).mm_Reveal(0);
		messageAll('MsgAdminForce', "\c3"@%pl.client.name@"\c2 was revealed (no kills made for "@NumToWord($MM_UseAutoReveal)@" second"@($MM_UseAutoReveal == 1 ? "" : "s")@")!");
	}
}

function MM_loadMapLoop(%file, %admin)
{
	%count = MainBrickgroup.getCount();
	for(%i=0;%i<%count;%i++)
		%sum += MainBrickgroup.getObject(%i).getCount();
	if(%sum == 0)
	{
		%read = new FileObject();
		%read.openForRead(%file);
		%read.readLine(); %read.readLine(); %lighting = %read.readLine();
		if(!isObject(%admin)) %admin = new ScriptObject() { isAdmin = 1; };
		servercmdEnvGui_SetVar(%admin, "DirectLightColor", %lighting);
		servercmdEnvGui_SetVar(%admin, "AmbientLightColor", %lighting);
		servercmdEnvGui_SetVar(%admin, "ShadowColor", %lighting);
		%read.close(); %read.delete(); %admin.delete();
		serverDirectSaveFileLoad(%file, 3, "", 0);
		MM_beginNextRound(-1);
	}
	else
		schedule(16, 0, "MM_loadMapLoop", %file, %admin);
}

function MM_beginNextRound(%last)
{
	%count = MainBrickgroup.getCount();
	for(%i=0;%i<%count;%i++)
		%sum += MainBrickgroup.getObject(%i).getCount();
	if(%sum == %last)
	{
		$MM_RoundsToNewSave = 5;
		murderMystery_startNewRound();
	}
	else
		schedule(1000, 0, "MM_beginNextRound", %sum);
}

datablock PlayerData(PlayerSlowArmor : PlayerNoJet)
{
	runForce = PlayerNoJet.runForce / 2;
	maxForwardSpeed = PlayerNoJet.maxForwardSpeed / 2;
	maxBackwardSpeed = PlayerNoJet.maxBackwardSpeed / 2;
	maxSideSpeed = PlayerNoJet.maxSideSpeed / 2;
	maxForwardCrouchSpeed = PlayerNoJet.maxForwardCrouchSpeed / 2;
	maxBackwardCrouchSpeed = PlayerNoJet.maxBackwardCrouchSpeed / 2;
	maxSideCrouchSpeed = PlayerNoJet.maxSideCrouchSpeed / 2;
	jumpForce = PlayerNoJet.jumpForce / 2;
	uiName = "Slow Player";
	showEnergyBar = false;
};

datablock PlayerData(PlayerReallySlowArmor : PlayerNoJet)
{
	runForce = PlayerNoJet.runForce / 5;
	maxForwardSpeed = PlayerNoJet.maxForwardSpeed / 5;
	maxBackwardSpeed = PlayerNoJet.maxBackwardSpeed / 5;
	maxSideSpeed = PlayerNoJet.maxSideSpeed / 5;
	maxForwardCrouchSpeed = PlayerNoJet.maxForwardCrouchSpeed / 5;
	maxBackwardCrouchSpeed = PlayerNoJet.maxBackwardCrouchSpeed / 5;
	maxSideCrouchSpeed = PlayerNoJet.maxSideCrouchSpeed / 5;
	jumpForce = PlayerNoJet.jumpForce / 5;
	uiName = "Slow Player";
	showEnergyBar = false;
};

datablock fxLightData(UnknownLight)
{
	LightOn = false;
	color = "1 1 1 1";
	flareOn = true;
	flarebitmap = "base/lighting/lightFalloffMono";
	NearSize = 1;
	FarSize = 1;
};

datablock fxLightData(MurdererLight)
{
	LightOn = false;
	color = "1 0 0 1";
	flareOn = true;
	flarebitmap = "base/lighting/lightFalloffMono";
	NearSize = 1;
	FarSize = 1;
};

datablock fxLightData(InnocentLight)
{
	LightOn = false;
	color = "0 1 0 1";
	flareOn = true;
	flarebitmap = "base/lighting/lightFalloffMono";
	NearSize = 1;
	FarSize = 1;
};

datablock fxLightData(DetectiveLight)
{
	LightOn = false;
	color = "0 0 1 1";
	flareOn = true;
	flarebitmap = "base/lighting/lightFalloffMono";
	NearSize = 1;
	FarSize = 1;
};

datablock fxLightData(RevealingLight)
{
	LightOn = false;
	color = "1 1 0 1";
	flareOn = true;
	flarebitmap = "base/lighting/lightFalloffMono";
	NearSize = 1;
	FarSize = 1;
};

exec("./Bot AI.cs");
exec("./Events.cs");
exec("./NumToWord.cs");